/* ************************************************************************* */
/*  ###  Finite-Elemente-Baukasten FEMSET  ###                               */
/*                                                                           */
/*  Initialisieren der Felder des rechnerinternen Modells                    */
/*  =====================================================                    */
/*                                                                           */
/*  Autor: J. Dankert                                                        */
/* ************************************************************************* */

#include    "femset_f.h"

void arrini_f (long    kx   , long    kf   , long    ke   , long    kp   ,
               long    ne   , long    nk   ,
               double *xy_p , long   *km_p , long   *et_p , double *ep_p ,
               double *bk_p , long   *kr_p , double *uv_p , double *sc_p ,
               long   *la_p , double *aa_p , long   *li_p , double *pu_p ,
               int    *ft_p)
{
   int i ;
   
   darnul_f (xy_p , nk * kx) ;
   iarnul_f (km_p , ne * ke) ;
   iarnul_f (et_p , ne * 5 ) ;
   darnul_f (ep_p , ne * kp) ;
   darnul_f (bk_p , nk * kf) ;
   iarnul_f (kr_p , nk     ) ;
   darnul_f (uv_p , nk * kf) ;
   darnul_f (sc_p , nk * kf) ;
   iarnul_f (la_p , nk     ) ;
   darnul_f (aa_p , nk * 3 ) ;
   iarnul_f (li_p , nk * kf) ;
   darnul_f (pu_p , nk * kf) ;
             
   for (i = 0 ; i < kf ; i++) *(ft_p + i) = i ;      
             
   return ;
}
