/* ************************************************************************* */
/*  ###  Finite-Elemente-Baukasten FEMSET  ###                               */
/*                                                                           */
/*  Rueckrechnung verhinderter Verschiebungen, die nicht mit einer           */
/*  Koordinatenrichtung uebereinstimmen (nur 2D-Probleme!)                   */
/*  ==============================================================           */
/*                                                                           */
/*  Autor: J. Dankert                                                        */
/* ************************************************************************* */

#include    <math.h>
#include    "femset_f.h"

void bouret_f (double *uv_p , long    nk  , long kf ,
               long   *la_p , double *aa_p)
{
  long      i  , k  ;
  double    sb , cb , beta ;

  for (i = 0 ; i < nk ; i++)
  {
    if (*(la_p+i) == 1)
    {
      beta = *(aa_p+i) * pi_f /180. ;
      sb   = sin (beta)             ;
      cb   = cos (beta)             ;
      k    = i * kf                 ;            /*  ... ist die UV-Position */
      *(uv_p+k+1) = *(uv_p+k) * sb  ;
      *(uv_p+k)   = *(uv_p+k) * cb  ;
    }
  }
}
