/* ************************************************************************* */
/*  ###  Finite-Elemente-Baukasten FEMSET  ###                               */
/*                                                                           */
/*  Einbau verhinderter Verschiebungen (Eigenschwingungen)                   */
/*  ======================================================                   */
/*                                                                           */
/*  Autor: J. Dankert                                                        */
/* ************************************************************************* */

#include    <math.h>
#include    "femset_f.h"

void expvec_f (double *x_p  , long ib ,
               long   *kr_p , long nk , long kf , long nred , long nrows)
{
  long      i  , j , k , jj , kk , n , lred , lnod , ikr , luv0 , jsav ;

  n    = nk   * kf ;
  lred = nred - 1  ;
  luv0 = -1        ;
  lnod = nk - 1    ;
  ikr  = 0         ;

  for (i = n - 1 ; i >= 0 ; i--)      /*  Schleife ueber alle Freiheitsgrade (intern)     */
  {
    if (luv0 == -1)
	{
		if (ikr > 0)
		{
           k   = ikr - (ikr / 10) * 10 ;  /*  Freiheitsgradnummer (behindert)    */
           ikr = (ikr - k) / 10        ;  /*  ikr-Rest  */
           luv0 = jsav * kf + k - 1  ;     /*  Behind. FG (intern) */
		}
		else
		{
          for (j = lnod ; j >= 0 ; j--)  /* Knotennummern (intern) */
		  {
            if (ikr == 0)
			{
			   ikr  = *(kr_p+j) ;          /*  "Behinderungs-Indikator"               */
			   lnod = j - 1     ;
			}

			if (ikr > 0)
			{
               k   = ikr - (ikr / 10) * 10 ;  /*  Freiheitsgradnummer (behindert)    */
               ikr = (ikr - k) / 10        ;  /*  ikr-Rest  */
               luv0 = j * kf + k - 1  ;     /*  Behind. FG (intern) */
     		   jsav = j ;
			   break ;
			}
		  }   /* Ende for j = ... */
		}
	}

	if (i == luv0)
	{
		for (j = 0 , jj = i * nrows ; j < nrows ; j++)
			*(x_p + jj++) = 0. ;

		luv0 = -1 ;
	}
	else
	{
		for (j = 0 , jj = i * nrows , kk = lred * nrows ; j < nrows ; j++)
			*(x_p + jj++) = *(x_p + kk++) ;

		lred-- ;
	}
  }
   return ;
}

