#include    <stdlib.h>
#include    <stdio.h>

#ifdef FEMSET_MAIN_f              /* In genau einer Datei (Empfehlung:  */
  #define  GLOBVAR_f              /* Datei mit main bzw. WinMain) muss  */            
#else                             /* folgende Anweisung stehen:         */
  #define  GLOBVAR_f  extern      /*                                    */
#endif                            /*      #define FEMSET_MAIN_f         */

GLOBVAR_f char WorkString_f[320] ;

/* Allgemeine Konstanten: ***********************************************/

#define  FMT_NOTHING_f              0     /* Zu erledigende Aufgabe     */
#define  FMT_LEQSTRC_f              1
#define  FMT_SKYLEQSTRC_f           2
#define  FMT_CALCULATEDIS_f        10     
#define  FMT_CALCULATESKY_f        11
#define  FMT_LISTDIS_f             12

#define  FSET_TRUSS2D_f            10     /* Finite-Element-Typen       */
#define  FSET_TRUSS2DT_f           11
#define  FSET_BEND2D_f             15
#define  FSET_BD2DEB_f             17
#define  FSET_BD2DKM_f          10015
#define  FSET_BEAM2D_f             20
#define  FSET_BM2DKM_f          10020
#define  FSET_TRUSS3D_f           110
#define  FSET_BEAM3D_f            120
#define  FSET_PLANE3_6_f         1036
#define  FSET_PLANE4_8_f         1037
#define  FSET_PLANE4_16_f        1416
#define  FSET_TORS3_6_f          2036

#define  FSPR_STARTSOLVER_f         0     /* Protokoll                  */
#define  FSPR_STARTALLOC_f         10  
#define  FSPR_STARTALLOCEWP_f      12
#define  FSPR_STARTSYSTEM_f        20  
#define  FSPR_STARTEWPMATRIZEN_f   22
#define  FSPR_ENDSYSTEM_f          30  
#define  FSPR_ENDEWPMATRIZEN_f     32
#define  FSPR_STARTCHOL_f          40 
#define  FSPR_STARTISIASB_f        42
#define  FSPR_ENDCHOL_f            50 
#define  FSPR_ENDISIASB_f          52
#define  FSPR_LINEQCHAR_f         110  

#define  FS_MATRIXSPACE_f           1  
#define  FS_VECTORSPACE_f           2  

/************************************************************************/

/* Daten des FEM-Berechnungsmodells: ************************************/

#ifdef FEMSET_MAIN_f
      long     kx_f = 0 ; 
      long     kf_f = 0 ;
      long     ke_f = 0 ;
      long     kp_f = 0 ;             /*  Element-Charakteristik        */
      
      long     ne_f = 0 ;             /*  Elementanzahl                 */
      long     nk_f = 0 ;             /*  Knotenanzahl                  */

      double   *xy_p_f   = NULL ;     /*  Knotenkoordinaten             */
      long     *km_p_f   = NULL ;     /*  Koinzidenzmatrix              */
      long     *et_p_f   = NULL ;     /*  Element-Typen                 */
      double   *ep_p_f   = NULL ;     /*  Elementparameter              */
      double   *bk_p_f   = NULL ;     /*  Knotenlasten                  */
      long     *kr_p_f   = NULL ;     /*  Randbedingungen               */
      double   *uv_p_f   = NULL ;     /*  Knotenverformungen            */
      double   *sc_p_f   = NULL ;     /*  Federsteifigkeiten            */
      long     *la_p_f   = NULL ;     /*  Lager unter Winkel            */
      double   *aa_p_f   = NULL ;     /*  Winkel fuer Lager             */
      long     *li_p_f   = NULL ;     /*  Identische Verschbgn.         */
      double   *pu_p_f   = NULL ;     /*  Vorgeschrbne. Versch.         */
      int      *ft_p_f   = NULL ;     /*  Freiheitsgradtypen            */

      long     n_f  = 0 ;             /*  Anzahl der Gleichungen        */
      long     ib_f = 0 ;             /*  Halbe Bandweite               */

      double   lineq_eps  = 1.e-8   ; /*  Abbruchschranke f. Gl.-Syst.  */
      double   isiasb_eps = 1.e-8   ; /*  Tol. rel. Fehler fuer Eigenw. */
      long     isiasb_imx = 10000   ; /*  Max. Anz. d. isiasb-Iteratnn. */
      double   grasch_eps = 1.e-30  ; /*  Divisionstest in grasch_f     */
      double   pi_f  =  3.141592654 ;

      double    StartTime_f = 0 ; 
      double    StiffTime_f = 0 ; 
      double    SolveTime_f = 0 ;
      
	  long      Iteration_f = 0 ;
      int       StiffMatSpace_f = FS_MATRIXSPACE_f ;  
#else
      GLOBVAR_f long     kx_f ;
      GLOBVAR_f long     kf_f ;
      GLOBVAR_f long     ke_f ;
      GLOBVAR_f long     kp_f ;       /*  Element-Charakteristik        */
      
      GLOBVAR_f long     ne_f ;       /*  Elementanzahl                 */
      GLOBVAR_f long     nk_f ;       /*  Knotenanzahl                  */

      GLOBVAR_f double   *xy_p_f ;    /*  Knotenkoordinaten             */
      GLOBVAR_f long     *km_p_f ;    /*  Koinzidenzmatrix              */
      GLOBVAR_f long     *et_p_f ;    /*  Element-Typen                 */
      GLOBVAR_f double   *ep_p_f ;    /*  Elementparameter              */
      GLOBVAR_f double   *bk_p_f ;    /*  Knotenlasten                  */
      GLOBVAR_f long     *kr_p_f ;    /*  Randbedingungen               */
      GLOBVAR_f double   *uv_p_f ;    /*  Knotenverformungen            */
      GLOBVAR_f double   *sc_p_f ;    /*  Federsteifigkeiten            */
      GLOBVAR_f long     *la_p_f ;    /*  Lager unter Winkel            */
      GLOBVAR_f double   *aa_p_f ;    /*  Winkel fuer Lager             */
      GLOBVAR_f long     *li_p_f ;    /*  Identische Verschbgn.         */
      GLOBVAR_f double   *pu_p_f ;    /*  Vorgeschrbne. Versch.         */
      GLOBVAR_f int      *ft_p_f ;    /*  Freiheitsgradtypen            */

      GLOBVAR_f long     n_f  ;       /*  Anzahl der Gleichungen        */
      GLOBVAR_f long     ib_f ;       /*  Halbe Bandweite               */

      GLOBVAR_f double   lineq_eps ;  /*  Abbruchschranke f. Gl.-Syst.  */
      GLOBVAR_f double   isiasb_eps ; /*  Tol. rel. Fehler fuer Eigenw. */
      GLOBVAR_f long     isiasb_imx ; /*  Max. Anz. d. isiasb-Iteratnn. */
      GLOBVAR_f double   grasch_eps ; /*  Divisionstest in grasch_f     */
      GLOBVAR_f double   pi_f     ;

      GLOBVAR_f double   StartTime_f ;
      GLOBVAR_f double   StiffTime_f ;
      GLOBVAR_f double   SolveTime_f ;

	  GLOBVAR_f long     Iteration_f     ;
      GLOBVAR_f int      StiffMatSpace_f ;  
#endif

/************************************************************************/

/* Prototypen der Funktionen fuer den FEM-Basis-Algorithmus: ************/

int  allcmd_f (void) ;
void arrini_f (long    kx   , long    kf   , long    ke   , long    kp   ,
               long    ne   , long    nk   ,
               double *xy_p , long   *km_p , long   *et_p , double *ep_p ,
               double *bk_p , long   *kr_p , double *uv_p , double *sc_p ,
               long   *la_p , double *aa_p , long   *li_p , double *pu_p ,
               int    *ft_p) ;
int  bg2dkm_f (long ie   , double *xy_p , long   *km_p , double *ep_p ,
              long kemx , long    kx   , long   *kf   , long   *ke   ,
              long kp   , double *ek_p , double *em_p) ;
int  bieg2d_f (long ie   , double *xy_p , long   *km_p , double *ep_p ,
               long kemx , long    kx   , long   *kf   , long   *ke   ,
               long kp   , double *em_p , double *eb_p) ;
int  bg2deb_f (long ie   , double *xy_p , long   *km_p , double *ep_p ,
               long kemx , long    kx   , long   *kf   , long   *ke   ,
               long kp   , double *em_p , double *eb_p) ;
void boubet_f (double *a_p  , double *b_p , long ib ,
               long    nk   , long    kf  ,
               long   *la_p , double *aa_p) ;
void boucon_f (double *a_p  , double *b_p , long ib ,
               long   *kr_p , long    nk  , long kf ,
               long   *li_p , double *pu_p) ;
void boueig_f (double *a_p  , double *b_p , long ib ,
               long   *kr_p , long    nk  , long kf) ;
void bouret_f (double *uv_p , long    nk  , long kf ,
               long   *la_p , double *aa_p) ;
int  cholba_f (double *a_p , long n , long ib , double eps) ;
int  convli_f (long *li_p , long nk , long kf) ;
void darnul_f (double *a , long n) ;
void darcop_f (double *a_p , double *b_p , long n) ;
long dimeig_f (long *km_p , long *et_p , 
               long  ne   , long  ke   , long  kf   , long nk , long *n_p) ;
long dimsys_f (long *km_p , long *et_p , long *li_p ,
               long  ne   , long  ke   , 
               long  kf   , long nk    , long *n_p) ;
int  elemat_f (long    ie   ,
               double *xy_p , long   *km_p , long   *et_p , double *ep_p ,
               long    kemx , long    kx   , long   *kf   , long   *ke   ,
               long    kp   , double *em_p , double *eb_p) ;
long elmtyp_f (long kx , long kf , long ke , long kp) ;
int  emstif_f (long ie   , double *xy_p , long   *km_p , double *ep_p ,
               long kemx , long    kx   , long   *kf   , long   *ke   ,
               long kp   , double *em_p , double *eb_p) ;
void evnorm_f (double *x_p , long m , long neiwe) ;
void expvec_f (double *x_p  , long ib ,
               long   *kr_p , long nk , long kf , long nred , long nrows) ;
int  fach2d_f (long ie   , double *xy_p , long   *km_p , double *ep_p ,
               long kemx , long    kx   , long   *kf   , long   *ke   ,
               long kp   , double *em_p , double *eb_p) ;
int  fact2d_f (long ie   , double *xy_p , long   *km_p , double *ep_p ,
               long kemx , long    kx   , long   *kf   , long   *ke   ,
               long kp   , double *em_p , double *eb_p) ;
int  fach3d_f (long ie   , double *xy_p , long   *km_p , double *ep_p ,
               long kemx , long    kx   , long   *kf   , long   *ke   ,
               long kp   , double *em_p , double *eb_p) ;
int  femalg_f (long    kx   , long    kf   , long    ke   ,
               long    kp   , long    ne   , long    nk   ,
               double *xy_p , long   *km_p , long   *et_p , double *ep_p ,
               long   *kr_p , double *bk_p , double *sc_p , long   *la_p ,
               double *aa_p , long   *li_p , double *pu_p , double *uv_p) ;
int  feskal_f (long    kx   , long    kf   , long    ke   ,
               long    kp   , long    ne   , long    nk   ,
               double *xy_p , long   *km_p , long   *et_p , double *ep_p ,
               long   *kr_p , double *bk_p , double *sc_p , long   *la_p ,
               double *aa_p , long   *li_p , double *pu_p , double *uv_p) ;
int  femeig_f (long    neig , long    kx   , long    kf   , long    ke   ,
               long    kp   , long    ne   , long    nk   ,
               double *xy_p , long   *km_p , long   *et_p , double *ep_p ,
               long   *kr_p , double *bk_p , double *sc_p , 
		       double *ev_p , double *x_p) ;
void fgtype_f (void) ;
int  finenk_f (FILE *femmod_p , long *kx , long *kf , long *ke  ,
                                long *kp , long *ne , long *nk) ;
int  finmod_f (FILE *femmod_p , long  kx   , long    kf   , long    ke   ,
                                long  kp   , long    ne   , long    nk   ,
               double *xy_p   , long *km_p , long   *et_p , double *ep_p ,
               double *bk_p   , long *kr_p , double *sc_p , long   *la_p ,
               double *aa_p   , long *li_p , double *pu_p) ;
int  foumod_f (FILE *femmod_p , long  kx   , long    kf   , long ke      ,
                                long  kp   , long    ne   , long nk      ,
               double *xy_p   , long *km_p , long   *et_p , double *ep_p ,
               double *bk_p   , long *kr_p , double *sc_p , long   *la_p ,
               double *aa_p   , long *li_p , double *pu_p , double *uv_p ,
               long    uvuse) ;
void fralla_f (void) ;
double 
     getnox_f (double *a_p , long ib , long n) ;
char *getstr_f
              (char *Text , int TextNr) ;
void grasch_f (double *x_p , double *b_p , double *r_p  , 
				 long    m   , long   ib , long   *neiwe) ;
long gteltp_f (long elnr) ;
void iarnul_f (long *ia , long n) ;
int isiasb_f (double *a_p     , double *b_p     , 
			  long   m        , long   iba      , long   ibb ,
			  long   neiw     , long   *itmax_p , double eps , 
			  long   *nkonv_p , double *eiwe_p  , double *x_p) ;
long lcdeig_f (double *a_p  , double *b_p , long ib ,
               long   *kr_p , long    nk  , long kf) ;	
void matmub_f (double *a_p , double *b_p , double *c_p ,
               long    ma  , long    ib  , long    nb) ;
void matmul_f (double *a_p , double *b_p , double *c_p ,
               long    ma  , long    mn  , long    nb) ;
void prtout_f (int nr) ;
int  rahm2d_f (long ie   , double *xy_p , long   *km_p , double *ep_p ,
               long kemx , long    kx   , long   *kf   , long   *ke   ,
               long kp   , double *em_p , double *eb_p) ;
int  rahm3d_f (long ie   , double *xy_p , long   *km_p , double *ep_p ,
               long kemx , long    kx   , long   *kf   , long   *ke   ,
               long kp   , double *em_p , double *eb_p) ;
int  restli_f (long *li_p , long nk , long kf) ;
int rm2dkm_f (long ie   , double *xy_p , long   *km_p , double *ep_p ,
              long kemx , long    kx   , long   *kf   , long   *ke   ,
              long kp   , double *ek_p , double *em_p) ;
int  sd6_f    (long ie   , double *xy_p , long   *km_p , double *ep_p ,
               long kemx , long    kx   , long   *kf   , long   *ke   ,
               long kp   , double *em_p , double *eb_p) ;
void skybcn_f (double **mdiag_pp , long *height_p , double *b_p , 
               long   *kr_p , long    nk  , long kf ,
               long   *li_p , double *pu_p) ;
void skybet_f (double **mdiag_pp , long *height_p , double *b_p ,
               long    nk   , long    kf  ,
               long   *la_p , double *aa_p) ;
int  skycho_f (long n , double *mdiag_p[] , long height[] , double eps) ;
void skyfsp_f (double **mdiag_pp , long *height_p , double *b_p) ;
void skyhgt_f (long *km_p , long *et_p , long *li_p ,
               long  ne   , long  kfmx , long kemx  ,
               long  nk   , long n_p   , long *height_p) ;
double 
     skynox_f (double **mdiag_pp , long n) ;
void skyslv_f (long n , double *mdiag_p[] , long height[] ,
                        double b[] , double x[]) ;
int  skyspa_f (double **mdiag_pp , long *height_p , long n) ;
void skyspc_f (double **mdiag_pp , double *sc_p , long nk , long kf) ;
int  skysys_f (double **mdiag_pp , long *height_p , double *b_p , 
               long    n    , long    ne , long    nk   , long    kx   ,
               long    kfmx , long  kemx , long    kp   , double *xy_p ,
               long   *km_p , long *et_p , double *ep_p , long   *li_p) ;
int  solver_f (int FemModTask) ;
void sortiv_f (double *x_p , double *eiwe_p , long m , long neiwe) ;
void spccon_f (double *a_p , long ib , double *sc_p ,
               long    nk  , long kf ) ;
int  sv16_f   (long ie   , double *xy_p , long   *km_p , double *ep_p ,
               long kemx , long    kx   , long   *kf   , long   *ke   ,
               long kp   , double *em_p , double *eb_p) ;
int  sv8_f    (long ie   , double *xy_p , long   *km_p , double *ep_p ,
               long kemx , long    kx   , long   *kf   , long   *ke   ,
               long kp   , double *em_p , double *eb_p) ;
int  syseig_f (double *a_p  , double *b_p  , long  n    , long    ib  ,
               long    ne   , long    nk   ,
               long    kx   , long    kfmx , long  kemx , long    kp  ,
               double *xy_p , long   *km_p , long *et_p , double *ep_p) ;
int  system_f (double *a_p  , double *b_p  , long  n    , long    ib   ,
               long    ne   , long    nk   ,
               long    kx   , long    kfmx , long  kemx , long    kp   ,
               double *xy_p , long   *km_p , long *et_p , double *ep_p ,
               long   *li_p) ;
int  torsd6_f (long ie   , double *xy_p , long   *km_p , double *ep_p ,
               long kemx , long    kx   , long   *kf   , long   *ke   ,
               long kp   , double *em_p , double *eb_p) ;
void vorrue_f (double *r_p , double *b_p , double *x_p ,
               long    n   , long    ib  , long    nb) ;
double ytbibx_f (double *xy_p , double *b_p , long m   , long ib ,
				 long   neiwe , long ispy   , long ispx) ;

/************************************************************************/

/* Prototypen der Funktionen, die sowohl von der FEM-Basis-Version ******/
/* als auch der Windows-Version aufgerufen werden (enthalten       ******/
/* Anweisungen, die vom Praeprozessorlauf abhaengig sind):         ******/

void *calloc_f (long nElems , size_t nByte) ;
void  fillin_f (int var , long iy , long jy) ;
void  freesp_f (void *h_p) ;
void  infbox_f (int head , int text) ;
void  infbx2_f (char *head_p , char *text_p) ;
void  lestrc_f (long n , long *hib_p , int task) ;
void  preleq_f (void) ;
void  protoc_f (int nr) ;

/************************************************************************/
