/* ************************************************************************* */
/*  ###  Finite-Elemente-Baukasten FEMSET  ###                               */
/*                                                                           */
/*  Lesen der Kopfzeilen einer femmod-Datei mit Element-Charakteristik,      */
/*  Element- und Knotenanzahl                                                */
/*  =========================================================                */
/*                                                                           */
/*  Eingabe: femmod_p  -  FILE-Pointer der zu lesenden Datei                 */
/*                                                                           */
/*  Return-Wert:    1  --->  Erfolg                                          */
/*                  0  --->  Misserfolg                                      */
/*                                                                           */
/*  Abgeliefert werden im Erfolgsfall ausserdem:                             */
/*                                                                           */
/*             kx    -  "Dimension" des Problems (1, 2 oder 3)               */
/*             kf    -  Maximale Anzahl der Freiheitsgrade pro Knoten        */
/*             ke    -  Maximale Knotenanzahl pro Element                    */
/*             kp    -  Anzahl der Parameter, die ein Element beschreiben    */
/*             ne    -  Elementanzahl                                        */
/*             nk    -  Knotenanzahl                                         */
/*                                                                           */
/*  Autor: J. Dankert                                                        */
/* ************************************************************************* */

#include    <stdio.h>
#include    "femset_f.h"

   int finenk_f (FILE *femmod_p , long *kx , long *kf ,
                                  long *ke , long *kp , long *ne , long *nk)
   {
      char     line [80] ;
      
      rewind (femmod_p) ;
      
      if (fgets  (line , 80 , femmod_p) == NULL)         return 0 ;
      if (fscanf (femmod_p , "%ld%ld%ld%ld\n" , kx , kf , ke , kp) != 4)
                                                         return 0 ;

      if (fgets  (line , 80 , femmod_p) == NULL)         return 0 ;
      if (fscanf (femmod_p , "%ld%ld\n" , ne , nk) != 2) return 0 ;

      return 1 ;
   }
