/* ************************************************************************* */
/*  ###  Finite-Elemente-Baukasten FEMSET  ###                               */
/*                                                                           */
/*  Typ eines Elements aus der Elementnummer bestimmen                       */
/*  ==================================================                       */
/*                                                                           */
/*  Es wird der Elementtyp aus der Matrix et_p_f abgeliefert. Wenn dort      */
/*  eine 0 eingetragen ist (moeglich beim Lesen von Files aelterer           */
/*  FEMSET-Versionen), wird mit elmtyp_f versucht, den Elementtyp aus der    */
/*  globalen Element-Charakteristik zu bestimmen.                            */
/*                                                                           */
/*  Eingabe:  elnr   -   Element-Nummer                                      */
/*                                                                           */
/*  Return-Wert ist der Elementtyp oder 0, wenn der Elementtyp               */
/*              nicht ermittelt werden kann.                                 */
/*                                                                           */
/*  Autor: J. Dankert                                                        */
/* ************************************************************************* */

#include    "femset_f.h"
                     
long gteltp_f (long elnr)
{   
   long eltyp ;

   eltyp = *(et_p_f + elnr * 5) ;
                      
   if (eltyp == 0)
   { 
     /* Versuch, den Elementtyp aus der Element-Charakteristik
        zu ermittelm:                                          */
     eltyp = elmtyp_f (kx_f , kf_f , ke_f , kp_f) ;
   }
   
   return eltyp ;  
}
