/* *********************************************************** */
/*  ###  Finite-Elemente-Baukasten FEMSET  ###                 */
/*                                                             */
/*  Matrizenmultiplikation  A * B = C                          */
/*  =================================                          */
/*                                                             */
/*  Eingabe:   a_p   -  Pointer auf Matrix mit ma Zeilen und   */
/*                      mn Spalten                             */
/*             b_p   -  Pointer auf Matrix mit mn Zeilen und   */
/*                      nb Spalten                             */
/*             ma    -  Zeilenanzahl der Matrix A              */
/*             mn    -  Spaltenanzahl der Matrix A bzw.        */
/*                      Zeilenanzahl  der Matrix B bzw.        */
/*             nb    -  Spaltenanzahl der Matrix B bzw.        */
/*                                                             */
/*  Ausgabe   *c_p   -  Matrix  C = A * B                      */
/*                                                             */
/*  Autor: J. Dankert                                          */
/* *********************************************************** */

#include    "femset_f.h"

void matmul_f (double *a_p , double *b_p , double *c_p ,
               long    ma  , long    mn  , long    nb)
{
  long    i , j , k , ij , kj , ki ;
  double  s ;

  for (i = 0 , ij = 0 ; i < ma ; i++)
    for (j = 0 ; j < nb ; j++)
    {
      s = 0. ;

      for (k = 0 , kj = i*mn , ki = j ; k < mn ; k++ , kj++ , ki += nb)
        s += *(a_p + kj) * *(b_p + ki) ;

      *(c_p + ij++) = s ;
    }
}
