/* ************************************************************************* */
/*  ###  Finite-Elemente-Baukasten FEMSET  ###                               */
/*                                                                           */
/*  Vorbereiten und Schreiben des Protokolls der FEM-Rechnung                */
/*  =========================================================                */
/*                                                                           */
/*  Autor: J. Dankert                                                        */
/* ************************************************************************* */

#include    <string.h>
#include    "femset_f.h"
#include    "w_fs_res.h"

void prtout_f (int nr)
{
   char Text[80] ;

   switch (nr)
   {
      case  FSPR_STARTALLOC_f:
      
         printf   (getstr_f (Text , S_SYSMAT_f)) ;
         printf   ("\n") ;
         strcpy   (WorkString_f , getstr_f (Text , S_LINEROWNR_f)) ;
         sprintf  (WorkString_f + strlen (WorkString_f) , "%6ld\n" , n_f)  ;
         printf   (WorkString_f) ;
         strcpy   (WorkString_f , getstr_f (Text , S_HALFBW_f)) ;
         sprintf  (WorkString_f + strlen (WorkString_f) , "%6ld\n\n" , ib_f) ;
         printf   (WorkString_f) ;
         break ;

      case  FSPR_STARTALLOCEWP_f:
      
         printf   (getstr_f (Text , S_ASEWP_f)) ;
         printf   ("\n") ;
         strcpy   (WorkString_f , getstr_f (Text , S_LINEROWNR_f)) ;
         sprintf  (WorkString_f + strlen (WorkString_f) , "%6ld\n" , n_f)  ;
         printf   (WorkString_f) ;
         strcpy   (WorkString_f , getstr_f (Text , S_HALFBW_f)) ;
         sprintf  (WorkString_f + strlen (WorkString_f) , "%6ld\n\n" , ib_f) ;
         printf   (WorkString_f) ;
         break ;

      case  FSPR_STARTSYSTEM_f:
      
         strcpy   (WorkString_f , getstr_f (Text , S_MAKELINEQ_f)) ;
         printf   (strcat (WorkString_f , " ...\n")) ;
         break ;

      case  FSPR_STARTEWPMATRIZEN_f:
      
         strcpy   (WorkString_f , getstr_f (Text , S_MAKEEWP_f)) ;
         printf   (strcat (WorkString_f , " ...\n")) ;
         break ;

      case  FSPR_ENDSYSTEM_f:
      
         strcpy   (WorkString_f , getstr_f (Text , S_MAKELINEQ_f)) ;
         sprintf  (WorkString_f + strlen (WorkString_f) ,
                                   ":%8.1f " , StiffTime_f) ;
         printf   (strcat (WorkString_f , getstr_f (Text , S_SECONDS_f))) ;
         printf   ("\n\n") ;
         break ;

      case  FSPR_ENDEWPMATRIZEN_f:
      
         strcpy   (WorkString_f , getstr_f (Text , S_MAKEEWP_f)) ;
         sprintf  (WorkString_f + strlen (WorkString_f) ,
                                   ":%8.1f " , StiffTime_f) ;
         printf   (strcat (WorkString_f , getstr_f (Text , S_SECONDS_f))) ;
         printf   ("\n\n") ;
         break ;

      case  FSPR_STARTCHOL_f:
      
         strcpy   (WorkString_f , getstr_f (Text , S_SOLVELINEQ_f)) ;
         printf   (strcat (WorkString_f , " ...\n")) ;
         break ;

      case  FSPR_STARTISIASB_f:
      
         strcpy   (WorkString_f , getstr_f (Text , S_SOLVEEWP_f)) ;
         printf   (strcat (WorkString_f , " ...\n")) ;
         break ;

      case  FSPR_ENDCHOL_f:
      
         strcpy   (WorkString_f , getstr_f (Text , S_SOLVELINEQ_f)) ;
         sprintf  (WorkString_f + strlen (WorkString_f) ,
                         ":%8.1f " , SolveTime_f) ;
         printf   (strcat (WorkString_f , getstr_f (Text , S_SECONDS_f))) ;
         printf   ("\n\n") ;
         break ;

      case  FSPR_ENDISIASB_f:
      
         strcpy   (WorkString_f , getstr_f (Text , S_SOLVEEWP_f)) ;
         sprintf  (WorkString_f + strlen (WorkString_f) ,
                         ":%8.1f " , SolveTime_f) ;
         printf   (strcat (WorkString_f , getstr_f (Text , S_SECONDS_f))) ;
         printf   ("\n") ;
         strcpy   (WorkString_f , getstr_f (Text , S_GRASCHITER_f)) ;
         sprintf  (WorkString_f + strlen (WorkString_f) ,
                         ":%6d " , Iteration_f) ;
         printf   (strcat (WorkString_f , getstr_f (Text , S_ITERATIONS_f))) ;
         printf   ("\n\n") ;
         break ;

      case FSPR_LINEQCHAR_f:
      
         printf   (getstr_f (Text , S_CHARLINEQ_f)) ;
         printf   ("\n") ;
         printf   (getstr_f (Text , S_SYSMATBR_f)) ;
         strcpy   (WorkString_f , getstr_f (Text , S_LINEROWNR_f)) ;
         sprintf  (WorkString_f + strlen (WorkString_f) , "%6ld\n" , n_f)  ;
         printf   (WorkString_f) ;
         strcpy   (WorkString_f , getstr_f (Text , S_HALFBW_f)) ;
         sprintf  (WorkString_f + strlen (WorkString_f) , "%6ld\n" , ib_f) ;
         printf   (WorkString_f) ;
         break ;
   }
}
