/* ************************************************************************* */
/*  ###  Finite-Elemente-Baukasten FEMSET  ###                               */
/*                                                                           */
/*  Rueck-Konvertierung des li_p-Feldes (identische Verschiebungen)          */
/*  vom Verarbeitungsformat in das Eingabeformat                             */
/*  ===============================================================          */
/*                                                                           */
/*  Autor: J. Dankert                                                        */
/* ************************************************************************* */

#include    "femset_f.h"
#include    "w_fs_res.h"

int restli_f (long *li_p , long nk , long kf)
{
  long  i , j , j1 , nfg ;
  long  *lisave_p ;                                         /*  Hilfsfeld    */

  nfg = nk * kf ;

  for (i = 0 ; i < nfg ; i++) if (*(li_p + i) != 0) break ;

  if (i >= nfg) return 1 ;                      /*  Es gibt nichts zu tun    */

  if ((lisave_p = (long *) calloc_f (nfg , sizeof (long))) == NULL) 
  {
    infbox_f (S_SORRY_f , S_RESTLISPACE_f) ;
    return 0 ;
  }

  for (i = 0 ; i < nfg ; i++) *(lisave_p+i) = 0 ;

  j1 = 1 ;
  for (i = 0 ; i < nfg ; i++)
  {
    if (*(li_p+i) > i)
    {
      j = *(li_p+i) ;
      if (*(lisave_p+j) == 0)
      {
        *(lisave_p+j) = j1 ;
        *(lisave_p+i) = j1 ;
        j1++             ;
      }
      else
        *(lisave_p+i) = *(lisave_p+j) ;
    }
  }

  for (i = 0 ; i < kf ; i++)
    for (j = 0 ; j < nk ; j++) 
    {
      j1                 = j * kf + i       ;
      *(li_p + i*nk + j) = *(lisave_p + j1) ;
    }

    freesp_f (lisave_p) ;                  /*  Speicherplatz freigeben       */
    return 1 ;
}
