/* ************************************************************************* */
/*  ###  Finite-Elemente-Baukasten FEMSET  ###                               */
/*                                                                           */
/*  Berechnung eines Wertes in der Groessenordnung der Original-             */
/*  Hauptdiagonalelemente, der fuer das Nullsetzen der Verschiebungen        */
/*  als Hauptdiagonalelement benutzt wird ("Skyline-Variante")               */
/*  =================================================================        */
/*                                                                           */
/*  Autor: J. Dankert                                                        */
/* ************************************************************************* */

#include    <math.h>
#include    "femset_f.h"

double skynox_f (double **mdiag_pp , long n)
   {
    long      i  ;
    double    ox ;

    for (i = 0 , ox = 0. ; i < n ; i++)
      ox += fabs (*(*(mdiag_pp + i))) ;

    return (ox / n) ;
   }
