/* ************************************************************************* */
/*  ###  Finite-Elemente-Baukasten FEMSET  ###                               */
/*                                                                           */
/*  Speicherplatz fuer Systemsteifigkeitsmatrix (Skyline-Variante)           */
/*  ==============================================================           */
/*                                                                           */
/*  Autor: J. Dankert                                                        */
/* ************************************************************************* */

#include    "femset_f.h"

int skyspa_f (double **mdiag_pp , long *height_p , long n)
{
     long naelem = 0 , i ;

     if (StiffMatSpace_f == FS_MATRIXSPACE_f)
     {
       for (i = 0 ; i < n ; i++) naelem += *(height_p + i) + 1 ;
     
       if (!(*(mdiag_pp) = (double *) calloc_f (naelem ,
                                                sizeof (double))))
       {                                     
         /* Versuch, mit Einzelanforderung fuer jeden "Schornstein"
            den Speicherplatz zu allokieren:                                 */
            
         StiffMatSpace_f = FS_VECTORSPACE_f ;
         skyspa_f (mdiag_pp , height_p , n) ;
       }
     
       for (i = 1 ; i < n_f ; i++)
       {
          *(mdiag_pp + i) = *(mdiag_pp + i - 1) + *(height_p + i - 1) + 1 ;
       }
     }
     else
     {
       for (i = 0 ; i < n_f ; i++)
       {
         if (!(*(mdiag_pp + i) = (double *) calloc_f (*(height_p + i) + 1 ,
                                              sizeof (double)))) return 0 ;
       }
     }

     return 1 ;
}
